Publicando novas versões
========================

Aqui estão algumas instruções para proceder com a liberação de novas versões, publicando os artefatos versionados tanto no NPM quanto no NUGET.

## 1. Determine a versão

* Altere a chave `version` no arquivo `package.json` para a versão determinada.
* Garanta que não exista artefatos de build's antigos
```console
$ npx gulp clean
```

* Gere os artefatos de distribuição da nova versão
```console
$ npx gulp dist
```

* Confirme as mudanças no Git

```console
$ git commit -m "Libera versão X"
```

> Não se esqueça de empurrar as mudanças para seu servidor remoto de Git.

> Onde "X" é o número da versão que você determinou

## 2. Publique no https://registry.npmjs.org

Você precisa estar autenticado no npm:
```console
$ npm login
Username: xxxxxx
Password:
Email: (this IS public) xxxxxx@xxxxx.xxx
Logged in as xxxxxx on https://registry.npmjs.org/.
```

Publique:
```console
$ npm publish
```

## 3. Publique no https://www.nuget.org
